#include "../debug/debug.h"
#include "../msr/msr.h"
#include "vxmon.h"
#include <asm/page.h>
#include <linux/errno.h>
#include <linux/printk.h>
#include <linux/slab.h>

struct vmxon_t *alloc_vmxon(void) {
    struct vmxon_t *vmxon = kzalloc(sizeof(struct vmxon_t), GFP_KERNEL);

    if (!vmxon) {
        DEBUG_FMT("VMXON region allocation has failed\n");
        return NULL;
    }

    vmxon->header.vmcs_rev_id = VMCS_REVISION_ID;
    vmxon->header.shadow_vmcs = 0;

    return vmxon;
}
